DisplayTrace("Kletskaya");
DisplayTrace("Une mission de Sur les traces des Panzers");
DisplayTrace("par LouisXIV");
------------------------------------------------------------------
function RevealObjective0()
	-- Display the briefing
	SetIGlobalVar("GameObjective1", 0);
	SetIGlobalVar("GameObjective2", 0);
	ObjectiveChanged(0, 0);
	Suicide();
end;

function Objective0()
	-- Remove the briefing objective
	ObjectiveChanged(0, 1);
	Suicide();
end;
------------------------------------------------------------------
function RevealObjective1()
	-- Display the first objective - the bridge in the town
	ObjectiveChanged(1, 0);
	Suicide();
end;

function Objective1()
	if ( GetNUnitsInScriptGroup(10, 1) <= 0) then
		SetIGlobalVar("GameObjective1", 1);
		RunScript("SecretObjective",1200000);
		ObjectiveChanged(1, 1);
		RunScript("Retirement",4000);
		Suicide();
	end;
end;
------------------------------------------------------------------
function RevealObjective2()
		ObjectiveChanged(2, 0);
		Suicide();
end;

function Objective2()
	if ( GetNUnitsInScriptGroup(11, 1) <= 0) then
		SetIGlobalVar("GameObjective2", 1);
		RunScript("SecretObjective",1200000);
		ObjectiveChanged(2, 1);
		RunScript("Retirement",4000);
		Suicide();
	end;
end;
------------------------------------------------------------------
function SecretObjective()
	if GetNUnitsInScriptGroup(1000,0) >= 5 then
		DisplayTrace("Les Sovitiques se sont rendus. Vous avez russi.");
		Win(0);
		Suicide();
	end;
end;
------------------------------------------------------------------
function Retirement()
	GiveCommand(3,2000,9800,5252);
	GiveQCommand(0,2000,9800,5252);
	GiveCommand(3,2001,9940,8848);
	GiveQCommand(0,2001,9940,8848);
	GiveQCommand(3,2000,12086,10338);
	GiveQCommand(0,2000,12086,10338);
	GiveQCommand(3,2001,12086,10338);
	GiveQCommand(0,2001,12086,10338);
	GiveCommand(3,2014,9000,8800);
	GiveCommand(31,2025,2015);
	GiveQCommand(32,2025,11500,12000);
	GiveQCommand(0,2025,11500,12200);
	GiveCommand(31,2026,2016);
	GiveQCommand(32,2026,12000,11500);
	GiveQCommand(0,2026,12000,11700);
	GiveCommand(31,2027,2017);
	GiveQCommand(32,2027,12500,11000);
	GiveQCommand(0,2027,12500,11200);
	GiveCommand(31,2028,2018);
	GiveQCommand(32,2028,13000,10500);
	GiveQCommand(0,2028,13000,10700);
	Suicide();
end;
------------------------------------------------------------------
function ToWin()
	if ( (GetIGlobalVar("GameObjective1", 0) * GetIGlobalVar("GameObjective2", 0)) == 1) then
		Win(0);
		Suicide();
	end;
end;

function TobeDefeated()
	if ( GetNUnitsInScriptGroup(1000, 0) <= 4) then
		Loose();
		Suicide();
	end;
end;
------------------------------------------------------------------
function Init()
	RunScript( "RevealObjective0", 1000);
	RunScript( "Objective0", 16000);
	RunScript( "RevealObjective1", 17000);
	RunScript( "Objective1", 40000);
	RunScript( "RevealObjective2", 22000);
	RunScript( "Objective2", 40000);
	RunScript( "ToWin", 5000);
	RunScript( "TobeDefeated", 5000);
end;
