DisplayTrace("Krasnograd");
DisplayTrace("Une mission de Sur les traces des Panzers");
DisplayTrace("par LouisXIV");
-------------------------------------------------------
function StartAtBresnin()
	ChangePlayer(212,2);
	ChangePlayer(213,2);
	ObjectiveChanged(0,0);
	--  Get the commander into his car.
	Cmd(4,210,209);
	--  Start it raining
	SwitchWeather(1);
	RunScript( "Droshnyi", 2000);
	RunScript( "BresninOut", 2000);
	Suicide();
end;

function Droshnyi()
	if (GetNScriptUnitsInArea(210,"Droshnii") > 0) then
		ObjectiveChanged(1,0);
		--  Start the Russian artillery firing
		Cmd(16, 120,11400,1140);
		Cmd(16, 121,11390,1145);
		Cmd(16, 122,11380,1150);
		--  Make the Droshnyi troops available to the player
	 	ChangePlayer(212,0);
		--  Swarm the Russian infantry to Bresnin
	 	Cmd(3,101,11340,1130);
		RunScript( "Tanks2Bresnin",40000);
		RunScript( "Krasnograd",2000);
		-- Keep it raining
		SwitchWeather(1);
		Suicide();
	end;
end;

function Krasnograd()
	if (GetNScriptUnitsInArea(210,"Krasnograd") > 0) then
		-- When commander figure gets to Krasnograd, change the garrison so they can be commanded.
		ObjectiveChanged(2,0);
		ChangePlayer(213,0);
		Suicide();
	end;
end;

function Tanks2Bresnin()
	--  Swarm the Russian tanks to Bresnin
	Cmd(3,100,11400,1200);
	-- Hook up the Russian artillery
	Cmd(31,111,120);
	Cmd(31,112,121);
	Cmd(31,113,122);
	SwitchWeather(1);
	Suicide();
end;

function BresninOut()
	if (GetNScriptUnitsInArea(211,"Bresnin") < 1) then
		ObjectiveChanged(0,2);
	 	DisplayTrace("Le contact radio avec Bresnin a t perdu");
		-- Send for German reinforcements
		RunScript( "Reinf215",30000);
		-- Deploy Russian artillery closer to Droshnyi
		Cmd(32,111,13900,3600);
		Cmd(32,112,14000,3700);
		Cmd(32,113,14100,3800);
		-- Prepare for the next attack on Droshnyi
		RunScript( "AttackDroshnyi",50000);
		-- Land support vehicles in Bresnin
		LandReinforcement(104);
		Suicide();
	end;
end;

function Reinf215()
	DisplayTrace("La division vous a fait parvenir des renforts");
	DisplayTrace("Les anti-chars mobiles vont arriver sous peu.");
	--  Bring in the AT and artillery
	LandReinforcement(215);
	Suicide();
end;

function AttackDroshnyi()
	-- Spring weather - lots of rain
	SwitchWeather(1);
	-- Send Russian infantry to attack Droshnyi
	Cmd(3,101,11373,7454);
	Cmd(3,110,11200,7500);
	--  Start the Russian artillery firing on Droshnyi
	Cmd(16, 120,11400,7500);
	Cmd(16, 121,11390,7000);
	Cmd(16, 122,11380,6500);
	-- 40 second delay to send Russian tanks after infantry
	RunScript( "Tanks2Droshnyi", 40000);
	-- Check to see if the garrison of Droshnyi is eliminated
	RunScript( "DroshnyiOut",2000);
	DeleteReinforcement(104);
	Suicide();
end;

function Tanks2Droshnyi()
	SwitchWeather(1);
	-- Send Russian tanks into the attack
	Cmd(3,100, 11373,7454);
	-- Hook up Russian artillery
	Cmd(31,111,120);
	Cmd(31,112,121);
	Cmd(31,113,122);
	Suicide();
end;

function DroshnyiOut()
	if (GetNScriptUnitsInArea(212,"Droshnii") < 1 ) then
		ObjectiveChanged(1,2);
		DisplayTrace("Le contact radio avec la garnison de Droshnyi a cess.");
		-- Deploy Russian artillery close to Droshnyi
		Cmd(32,111,12000,6000);
		Cmd(32,112,12100,6100);
		Cmd(32,113,12200,6200);
		-- Land support trucks north of Droshnyi
		LandReinforcement(105);
		-- Send troops to next staging area
		Cmd(0,100,7800,13000);
		Cmd(0,105,7900,13500);
		Cmd(0,101,7700,12500);
		-- Attack Krasnograd after 50 second delay
		RunScript( "AttackKrasnograd", 50000);
		-- Bring in Sturmgeschuetz reinforcements after 10 second delay
		RunScript( "Reinf216",10000);
		Suicide();
	end;
end;

function Reinf216()
	-- Bring in the sturmgeschuetzen
	DisplayTrace("Lezs anti-chars mobiles sont arrivs.");
	LandReinforcement(216);
	Suicide();
end;

function AttackKrasnograd()
	-- Start Russian artillery barrage on Krasnograd
	Cmd(16, 120,6700,6900);
	Cmd(16, 121,6700,7100);
	Cmd(16, 122,6700,7300);
	-- Swarm Russian infantry to Krasnograd
	Cmd(3,101,4700,7160);
	-- Follow up with Russian tanks after 40 second delay
	RunScript("Tanks2Krasnograd",40000);
	Suicide();
end;

function Tanks2Krasnograd()
	-- Send tanks in
	Cmd(3,100,4800,7160);
	Cmd(3,110,4800,7200);
	-- Raise artillery barrage to rear of Krasnograd
	Cmd(16, 120,4900,6900);
	Cmd(16, 121,4800,7100);
	Cmd(16, 122,4700,7300);
	-- Delay stopping artillery barrage
	RunScript( "PickUpArtillery",60000);
	Suicide();
end;

function PickUpArtillery()
	-- Hook up Russian artillery
	Cmd(31,111,120);
	Cmd(31,112,121);
	Cmd(31,113,122);
	Suicide();
end;

function KrasnogradOut()
	if ((GetNScriptUnitsInArea(213,"Krasnograd")) < 1) then
		ObjectiveChanged(2,2);
		-- Swarm everything to supply depot immediately
		Cmd(3,101,450,7000);
		Cmd(3,100,400,7000);
		Suicide();
	end;
end;

function ToWin()
	if  ((GetNUnitsInScriptGroup(100, 1)  < 1)) then
	 	Cmd(0,101,16380,1400);
	 	DisplayTrace("The Russians are retreating!");
	 	RunScript( "Winner", 30000);  
	 	Suicide();
	end;
end;


function Winner()
	Win(0);
	Suicide();
end;

function TobeDefeated()
	if ((GetNScriptUnitsInArea(100, "Depot") >= 1)) then
	 	DisplayTrace("Les Sovitiques ont perc et dtruit le dpt.");
	 	Loose();
	 	Suicide();
	end;
end;

function Init()
	RunScript( "StartAtBresnin", 1000);
	RunScript( "ToWin", 4000);
	RunScript( "TobeDefeated", 4000);
	Suicide();
end;
