DisplayTrace("Stoskol");
DisplayTrace("Une missions Sur les traces des Panzers");
DisplayTrace("par LouisXIV");
-------------------------------------------------
function RevealObjective0()
	-- First objective: Start Encirclement
	ObjectiveChanged(0, 0);
	Suicide();
end;
-------------------------------------------------
function RevealObjective1()
	-- Main objective: Occupy Stoskol
	ObjectiveChanged(1, 0);
	Suicide();
end;
-------------------------------------------------
function RevealObjective2()
	-- Next objective; Set up a supply depot in Stoskol
	ObjectiveChanged(2,0);
	Suicide();
end;
-------------------------------------------------
function RevealObjective3()
	-- Secret objective; Finish the encirclement
	ObjectiveChanged(3,0);
	Suicide();
end;
-------------------------------------------------
function Engineering()
	-- If the engineering truck (999) arrives in front of the warehouse
	if (GetNScriptUnitsInArea(999,"SupplyDepot")) > 0 then
		--  Start setting up the supply depot
		RunScript("SetUpDepot",4000);
		Suicide();
	end;
end;

function SetUpDepot()
	-- Bring in steel drums
	LandReinforcement(996);
	-- Bring in more after 4 seconds
	RunScript("MoreDepot",4000);
	Suicide()
end;

function MoreDepot()
	-- Bring in covered crates
	LandReinforcement(997);
	-- Bring in the main component of the supply depot
	RunScript("MainDepot",4000);
	Suicide();
end;

function MainDepot()
	-- Bring in the supply depot itself, and the supply warehouse hidden in the corner
	LandReinforcement(998);
	ObjectiveChanged(0,1);
	Suicide();
end;
----------------------------------------------
function Land500()
	-- Bring on Russian tanks
	LandReinforcement(500);
	-- Set the tanks in motion
	RunScript( "MoveTanks",2000);
	-- Bring in more fleeing Russian units
	RunScript( "Land501",1000);
	RunScript( "Land504",3000);
	RunScript( "Land505",4000);
	RunScript( "Land506",5000);
	RunScript( "Land507",5000);
	Suicide();
end;

function MoveTanks()
	-- Swarm tanks to exit area
	GiveCommand(3,500,15470,12514);
	-- Run the script that checks to see if tanks have arrived
	RunScript( "TanksAtTarget",3000);
	Suicide();
end;

function TanksAtTarget()
	-- if the tanks have arrived at their target zone
	if ((GetNScriptUnitsInArea(500,"Target500")) > 0 ) then
		-- Get rid of them
		DeleteReinforcement(500);
		-- Bring them on back at their starting zone
		LandReinforcement(500);
		-- And set them in motion again
		RunScript( "MoveTanks",2000);
		Suicide();
	end;
end;
------------------------------------------------------------------106
function Land501()
	LandReinforcement(501);
	RunScript("Convoy",5000);
	Suicide();
end;

function Convoy()
	RunScript( "ConvoyAtTarget",4000);
	GiveCommand(0,501,11361,3955);
	GiveQCommand(0,501,11761,5631);
	GiveQCommand(0,501,11598,7918);
	GiveQCommand(0,501,10165,9526);
	GiveQCommand(0,501,7904,9794);
	GiveQCommand(0,501,6551,10576);
	GiveQCommand(0,501,4186,10754);
	GiveQCommand(0,501,2970,12115);
	GiveQCommand(0,501,389,12941);
	Suicide();
end;

function ConvoyAtTarget()
	if ((GetNScriptUnitsInArea(501,"Target501")) > 0 ) then
		DeleteReinforcement(501);
		RunScript( "Land501",2000);
		Suicide();
	end;
end;
---------------------------------------------136
function Land504()
	LandReinforcement(504);
	RunScript( "Move504",5000);
	Suicide();
end;

function Move504()
	GiveCommand(3,504,10492,15877);
	RunScript( "AtTarget504",3000);
	Suicide();
end;

function AtTarget504()
	if ((GetNScriptUnitsInArea(504,"Target504")) > 0 ) then
		DeleteReinforcement(504);
		LandReinforcement(504);
		RunScript( "Move504",2000);
		Suicide();
	end;
end;
---------------------------------------------------------157
function Land505()
	-- Bring on mixed group of recurring reinforcements
	LandReinforcement(505);
	RunScript( "Move505",4000);
	-- Call to move Last Group
	Suicide();
end;

function Move505()
	-- Last group moving
	GiveCommand(3,505,4105,16045);
	-- Now run check to see if Last Group has reached target.
	RunScript( "AtTarget505",3000);
	Suicide();
end;

function AtTarget505()
	--  Check to see if Last Group at target");
	if ((GetNScriptUnitsInArea(505,"Target505")) > 0 ) then
		DeleteReinforcement(505);
		LandReinforcement(505);
		RunScript( "Move505",4000);
		Suicide();
	end;
end;
----------------------------------------------183
function Land506()
	-- Bring on Russian infantry
	LandReinforcement(506);
	-- Set the infantry in motion
	RunScript( "Move506",5000);
	-- Bring in more fleeing Russian units
	Suicide();
end;

function Move506()
	-- Swarm tanks to exit area
	GiveCommand(3,506,15470,12514);
	-- Run the script that checks to see if tanks have arrived
	RunScript( "AtTarget506",3000);
	Suicide();
end;

function AtTarget506()
	-- if the infantry have arrived at their target zone
	if ((GetNScriptUnitsInArea(506,"Target500")) > 0 ) then
		-- Get rid of them
		DeleteReinforcement(506);
		-- Bring them on back at their starting zone
		LandReinforcement(506);
		-- And set them in motion again
		RunScript( "Move506",2000);
		Suicide();
	end;
end;
---------------------------------------------217
function Land507()
	LandReinforcement(507);
	RunScript( "Move507",5000);
	Suicide();
end;

function Move507()
	GiveCommand(3,507,10492,15877);
	RunScript( "AtTarget507",3000);
	Suicide();
end;

function AtTarget507()
	if ((GetNScriptUnitsInArea(507,"Target504")) > 0 ) then
		DeleteReinforcement(507);
		LandReinforcement(507);
		RunScript( "Move507",2000);
		Suicide();
	end;
end;
----------------------------------------------------240
function WinDelay()
	RunScript( "ToWin",4000);
	Suicide();
end;	

function ToWin()
	if (((GetNUnitsInScriptGroup(500,1)) + (GetNUnitsInScriptGroup(501,1)) + (GetNUnitsInScriptGroup(504,1)) + (GetNUnitsInScriptGroup(505,1)) + (GetNUnitsInScriptGroup(506,1)) + (GetNUnitsInScriptGroup(507,1))) == 0 ) then
		Win(0);
		Suicide();
	end;
end;

function ToBeDefeated()
	if (((GetNUnitsInScriptGroup(200,0)) + (GetNUnitsInScriptGroup(201,0))) < 1) then
		Loose();
		Suicide();
	end;
end;
-----------------------------------------------
function Init()
	RunScript( "WinDelay",60000);
	RunScript( "ToBeDefeated",10000);
	RunScript( "Land500",1000);
	RunScript( "Engineering",5000);
	RunScript( "MainObjective",10000);
	RunScript("RevealObjective0",2000);
	RunScript("RevealObjective1",8000);
	RunScript("RevealObjective2",12000);
	RunScript("RevealObjective3",16000);
end;

---*** End of Script ***---